/** @file ute-mux-clo.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.5
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef UTE_MUX_CLO_H
#define UTE_MUX_CLO_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef MUX_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define MUX_PARSER_PACKAGE "ute mux"
#endif

#ifndef MUX_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define MUX_PARSER_PACKAGE_NAME "ute mux"
#endif

#ifndef MUX_PARSER_VERSION
/** @brief the program version */
#define MUX_PARSER_VERSION VERSION
#endif

enum enum_flavour { flavour__NULL = -1, flavour_arg_b = 0, flavour_arg_a, flavour_arg_t };

/** @brief Where the command line options are stored */
struct mux_args_info
{
  const char *version_help; /**< @brief Print version and exit help description.  */
  const char *help_help; /**< @brief Show this help message. help description.  */
  char * format_arg;	/**< @brief Use the specified parser, see below for a list.  */
  char * format_orig;	/**< @brief Use the specified parser, see below for a list original value given at command line.  */
  const char *format_help; /**< @brief Use the specified parser, see below for a list help description.  */
  char * output_arg;	/**< @brief Write result to specified output file.  */
  char * output_orig;	/**< @brief Write result to specified output file original value given at command line.  */
  const char *output_help; /**< @brief Write result to specified output file help description.  */
  char * into_arg;	/**< @brief Write result into ute file FILE.  */
  char * into_orig;	/**< @brief Write result into ute file FILE original value given at command line.  */
  const char *into_help; /**< @brief Write result into ute file FILE help description.  */
  char * name_arg;	/**< @brief For single-security files use NAME as security symbol.  */
  char * name_orig;	/**< @brief For single-security files use NAME as security symbol original value given at command line.  */
  const char *name_help; /**< @brief For single-security files use NAME as security symbol help description.  */
  char * zone_arg;	/**< @brief Treat dates/times as in time zone NAME (default UTC).  */
  char * zone_orig;	/**< @brief Treat dates/times as in time zone NAME (default UTC) original value given at command line.  */
  const char *zone_help; /**< @brief Treat dates/times as in time zone NAME (default UTC) help description.  */
  int refdate_arg;	/**< @brief Use STAMP as reference point for time values instead of epoch.  */
  char * refdate_orig;	/**< @brief Use STAMP as reference point for time values instead of epoch original value given at command line.  */
  const char *refdate_help; /**< @brief Use STAMP as reference point for time values instead of epoch help description.  */
  enum enum_flavour flavour_arg;	/**< @brief Data flavour (bid, ask, trade) for flavour-agnostic formats.  */
  char * flavour_orig;	/**< @brief Data flavour (bid, ask, trade) for flavour-agnostic formats original value given at command line.  */
  const char *flavour_help; /**< @brief Data flavour (bid, ask, trade) for flavour-agnostic formats help description.  */
  int multiplier_arg;	/**< @brief Multiply price values by INT, for fractions also use --magnifier.  */
  char * multiplier_orig;	/**< @brief Multiply price values by INT, for fractions also use --magnifier original value given at command line.  */
  const char *multiplier_help; /**< @brief Multiply price values by INT, for fractions also use --magnifier help description.  */
  int magnifier_arg;	/**< @brief Price values are regarded as if multiplied by INT, for better divisibility consider --multiplier.  */
  char * magnifier_orig;	/**< @brief Price values are regarded as if multiplied by INT, for better divisibility consider --multiplier original value given at command line.  */
  const char *magnifier_help; /**< @brief Price values are regarded as if multiplied by INT, for better divisibility consider --multiplier help description.  */
  
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int format_given ;	/**< @brief Whether format was given.  */
  unsigned int output_given ;	/**< @brief Whether output was given.  */
  unsigned int into_given ;	/**< @brief Whether into was given.  */
  unsigned int name_given ;	/**< @brief Whether name was given.  */
  unsigned int zone_given ;	/**< @brief Whether zone was given.  */
  unsigned int refdate_given ;	/**< @brief Whether refdate was given.  */
  unsigned int flavour_given ;	/**< @brief Whether flavour was given.  */
  unsigned int multiplier_given ;	/**< @brief Whether multiplier was given.  */
  unsigned int magnifier_given ;	/**< @brief Whether magnifier was given.  */

  char **inputs ; /**< @brief unamed options (options without names) */
  unsigned inputs_num ; /**< @brief unamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct mux_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure mux_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure mux_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *mux_args_info_purpose;
/** @brief the usage string of the program */
extern const char *mux_args_info_usage;
/** @brief all the lines making the help output */
extern const char *mux_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int mux_parser (int argc, char **argv,
  struct mux_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use mux_parser_ext() instead
 */
int mux_parser2 (int argc, char **argv,
  struct mux_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int mux_parser_ext (int argc, char **argv,
  struct mux_args_info *args_info,
  struct mux_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int mux_parser_dump(FILE *outfile,
  struct mux_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int mux_parser_file_save(const char *filename,
  struct mux_args_info *args_info);

/**
 * Print the help
 */
void mux_parser_print_help(void);
/**
 * Print the version
 */
void mux_parser_print_version(void);

/**
 * Initializes all the fields a mux_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void mux_parser_params_init(struct mux_parser_params *params);

/**
 * Allocates dynamically a mux_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized mux_parser_params structure
 */
struct mux_parser_params *mux_parser_params_create(void);

/**
 * Initializes the passed mux_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void mux_parser_init (struct mux_args_info *args_info);
/**
 * Deallocates the string fields of the mux_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void mux_parser_free (struct mux_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int mux_parser_required (struct mux_args_info *args_info,
  const char *prog_name);

extern const char *mux_parser_flavour_values[];  /**< @brief Possible values for flavour. */


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* UTE_MUX_CLO_H */
