/** @file ute-slab-clo.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.5
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef UTE_SLAB_CLO_H
#define UTE_SLAB_CLO_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef SLAB_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define SLAB_PARSER_PACKAGE "ute slab"
#endif

#ifndef SLAB_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define SLAB_PARSER_PACKAGE_NAME "ute slab"
#endif

#ifndef SLAB_PARSER_VERSION
/** @brief the program version */
#define SLAB_PARSER_VERSION VERSION
#endif

/** @brief Where the command line options are stored */
struct slab_args_info
{
  const char *version_help; /**< @brief Print version and exit help description.  */
  const char *help_help; /**< @brief Show this help message. help description.  */
  char * output_arg;	/**< @brief Write result to specified output file.  */
  char * output_orig;	/**< @brief Write result to specified output file original value given at command line.  */
  const char *output_help; /**< @brief Write result to specified output file help description.  */
  char * into_arg;	/**< @brief Write result into ute file FILE.  */
  char * into_orig;	/**< @brief Write result into ute file FILE original value given at command line.  */
  const char *into_help; /**< @brief Write result into ute file FILE help description.  */
  char ** extract_symbol_arg;	/**< @brief Extract ticks regarding SYM, can be comma-separated list or used multiple times.  */
  char ** extract_symbol_orig;	/**< @brief Extract ticks regarding SYM, can be comma-separated list or used multiple times original value given at command line.  */
  unsigned int extract_symbol_min; /**< @brief Extract ticks regarding SYM, can be comma-separated list or used multiple times's minimum occurreces */
  unsigned int extract_symbol_max; /**< @brief Extract ticks regarding SYM, can be comma-separated list or used multiple times's maximum occurreces */
  const char *extract_symbol_help; /**< @brief Extract ticks regarding SYM, can be comma-separated list or used multiple times help description.  */
  int* extract_symidx_arg;	/**< @brief Extract ticks with index IDX, can be comma-separated list or used multiple times.  */
  char ** extract_symidx_orig;	/**< @brief Extract ticks with index IDX, can be comma-separated list or used multiple times original value given at command line.  */
  unsigned int extract_symidx_min; /**< @brief Extract ticks with index IDX, can be comma-separated list or used multiple times's minimum occurreces */
  unsigned int extract_symidx_max; /**< @brief Extract ticks with index IDX, can be comma-separated list or used multiple times's maximum occurreces */
  const char *extract_symidx_help; /**< @brief Extract ticks with index IDX, can be comma-separated list or used multiple times help description.  */
  char * extract_from_arg;	/**< @brief Extract all ticks younger than STMP..  */
  char * extract_from_orig;	/**< @brief Extract all ticks younger than STMP. original value given at command line.  */
  const char *extract_from_help; /**< @brief Extract all ticks younger than STMP. help description.  */
  char * extract_till_arg;	/**< @brief Extract all ticks older than STMP..  */
  char * extract_till_orig;	/**< @brief Extract all ticks older than STMP. original value given at command line.  */
  const char *extract_till_help; /**< @brief Extract all ticks older than STMP. help description.  */
  char * extract_day_arg;	/**< @brief Short for --extract-from='DATE' --extract-till='DATE'.  */
  char * extract_day_orig;	/**< @brief Short for --extract-from='DATE' --extract-till='DATE' original value given at command line.  */
  const char *extract_day_help; /**< @brief Short for --extract-from='DATE' --extract-till='DATE' help description.  */
  
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int output_given ;	/**< @brief Whether output was given.  */
  unsigned int into_given ;	/**< @brief Whether into was given.  */
  unsigned int extract_symbol_given ;	/**< @brief Whether extract-symbol was given.  */
  unsigned int extract_symidx_given ;	/**< @brief Whether extract-symidx was given.  */
  unsigned int extract_from_given ;	/**< @brief Whether extract-from was given.  */
  unsigned int extract_till_given ;	/**< @brief Whether extract-till was given.  */
  unsigned int extract_day_given ;	/**< @brief Whether extract-day was given.  */

  char **inputs ; /**< @brief unamed options (options without names) */
  unsigned inputs_num ; /**< @brief unamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct slab_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure slab_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure slab_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *slab_args_info_purpose;
/** @brief the usage string of the program */
extern const char *slab_args_info_usage;
/** @brief all the lines making the help output */
extern const char *slab_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int slab_parser (int argc, char **argv,
  struct slab_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use slab_parser_ext() instead
 */
int slab_parser2 (int argc, char **argv,
  struct slab_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int slab_parser_ext (int argc, char **argv,
  struct slab_args_info *args_info,
  struct slab_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int slab_parser_dump(FILE *outfile,
  struct slab_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int slab_parser_file_save(const char *filename,
  struct slab_args_info *args_info);

/**
 * Print the help
 */
void slab_parser_print_help(void);
/**
 * Print the version
 */
void slab_parser_print_version(void);

/**
 * Initializes all the fields a slab_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void slab_parser_params_init(struct slab_parser_params *params);

/**
 * Allocates dynamically a slab_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized slab_parser_params structure
 */
struct slab_parser_params *slab_parser_params_create(void);

/**
 * Initializes the passed slab_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void slab_parser_init (struct slab_args_info *args_info);
/**
 * Deallocates the string fields of the slab_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void slab_parser_free (struct slab_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int slab_parser_required (struct slab_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* UTE_SLAB_CLO_H */
